"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommandBus = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
require("reflect-metadata");
const constants_1 = require("@nestjs/cqrs/dist/decorators/constants");
const cqrs_1 = require("@nestjs/cqrs");
const cqrs_2 = require("@nestjs/cqrs");
const services_1 = require("./services");
const decorators_1 = require("./decorators");
let CommandBus = class CommandBus extends cqrs_2.CommandBus {
    constructor(_moduleRef, _nmc) {
        super(_moduleRef);
        this._moduleRef = _moduleRef;
        this._nmc = _nmc;
    }
    isExternal(command) {
        return Reflect.getMetadata(decorators_1.EXTERNAL_COMMAND_METADATA, command.constructor);
    }
    emit(command) {
        return new Promise((res, rej) => {
            const result = this._nmc.emit(command.constructor.name, command.json());
            res(result);
        });
    }
    execute(command) {
        if (this.isExternal(command)) {
            return this.emit(command);
        }
        else {
            return this.executeLocally(command);
        }
    }
    executeLocally(command) {
        return super.execute(command);
    }
    registerHandler(handler) {
        const instance = this._moduleRef.get(handler, { strict: false });
        if (!instance) {
            return;
        }
        const target = this._reflectCommandName(handler);
        if (!target) {
            throw new cqrs_1.InvalidCommandHandlerException();
        }
        if (this._reflectGlobalCommand(target)) {
            this.subscribeGlobally(target);
        }
        this.bind(instance, target.name);
    }
    subscribeGlobally(command) {
        const that = this;
        this._nmc.addHandler(command.name, (name, data) => {
            const instance = new command();
            instance.fromObj(data);
            return that.executeLocally(instance);
        });
    }
    _reflectGlobalCommand(command) {
        return Reflect.getMetadata(decorators_1.EXTERNAL_COMMAND_METADATA, command);
    }
    _reflectCommandName(handler) {
        return Reflect.getMetadata(constants_1.COMMAND_HANDLER_METADATA, handler);
    }
};
CommandBus = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [core_1.ModuleRef,
        services_1.NestjsMicroservicesCqrs])
], CommandBus);
exports.CommandBus = CommandBus;
