"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SerializableCommand = void 0;
class SerializableCommand {
    json() {
        return JSON.stringify(this);
    }
    fromJson(json) {
        const jsonObj = JSON.parse(json);
        for (let propName in jsonObj) {
            if (jsonObj.hasOwnProperty(propName) && this.hasOwnProperty(propName)) {
                this[propName] = jsonObj[propName];
            }
        }
    }
    fromObj(jsonObj) {
        for (let propName in jsonObj) {
            if (jsonObj.hasOwnProperty(propName) && this.hasOwnProperty(propName)) {
                this[propName] = jsonObj[propName];
            }
        }
    }
}
exports.SerializableCommand = SerializableCommand;
