import { CustomStrategy, MicroserviceOptions } from '@nestjs/microservices';
import { IEvent } from "@nestjs/cqrs";
import { Observable } from "rxjs";
export declare class NestjsMicroservicesCqrs<EventBase extends IEvent = IEvent> {
    private options;
    private server;
    private client;
    run(messagePatterns: string[], options: MicroserviceOptions): void;
    init(options: MicroserviceOptions): CustomStrategy;
    private _createServer;
    private _createClient;
    addHandler<U>(pattern: string, handler: (name: string, data: any) => U): void;
    emit<TResult = any>(pattern: string, data: any): Promise<Observable<TResult>> | null;
    send<TResult = any>(pattern: string, data: any): Observable<TResult>;
}
