"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NestjsMicroservicesCqrs = void 0;
const common_1 = require("@nestjs/common");
const microservices_1 = require("@nestjs/microservices");
const server_factory_1 = require("@nestjs/microservices/server/server-factory");
const client_proxy_1 = require("@nestjs/microservices/client/client-proxy");
const rxjs_1 = require("rxjs");
class SubscribableClientProxy extends client_proxy_1.ClientProxy {
}
let NestjsMicroservicesCqrs = class NestjsMicroservicesCqrs {
    run(messagePatterns, options) {
        if (!this.client) {
            this._createClient(messagePatterns, options);
        }
    }
    init(options) {
        return this._createServer(options);
    }
    ;
    _createServer(options) {
        this.options = options;
        const server = server_factory_1.ServerFactory.create(options);
        this.server = server;
        this.client = undefined;
        return { strategy: server };
    }
    _createClient(messagePatterns, options) {
        const client = microservices_1.ClientProxyFactory.create(options);
        if (client) {
            if (typeof client.subscribeToResponseOf === 'function') {
                messagePatterns.forEach(message => client.subscribeToResponseOf(message));
            }
            client.connect();
            this.client = client;
        }
    }
    addHandler(pattern, handler) {
        if (this.server) {
            let oldHandler;
            oldHandler = this.server.getHandlerByPattern(pattern);
            let finalHandler;
            if (!(oldHandler && oldHandler.isGlobal)) {
                finalHandler = (data, ctx) => {
                    let res;
                    if (oldHandler instanceof Function) {
                        res = oldHandler(data, ctx);
                    }
                    const res2 = handler(pattern, data.value);
                    return Promise.resolve(res2);
                };
                finalHandler.isEventHandler = true;
                finalHandler.isGlobal = true;
                this.server.addHandler(pattern, finalHandler, true);
            }
        }
    }
    emit(pattern, data) {
        if (this.client) {
            return this.client.emit(pattern, data).toPromise();
        }
        return null;
    }
    send(pattern, data) {
        if (this.client) {
            return this.client.send(pattern, data);
        }
        return rxjs_1.of(null);
    }
};
NestjsMicroservicesCqrs = __decorate([
    common_1.Injectable()
], NestjsMicroservicesCqrs);
exports.NestjsMicroservicesCqrs = NestjsMicroservicesCqrs;
